unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ViewPanel, CAD2DCmp, StdCtrls, Buttons, ExtCtrls,
  GrLib2D, Prim2D, Obj2D, Block2D,
  Menus, Printers, ClipBrd, Math;

type
  TForm1 = class(TForm)
    CADCmp1: TCADCmp;
    ViewportPanel1: TViewportPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Load1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    About1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    PopupMenu1: TPopupMenu;
    ZoomIn1: TMenuItem;
    ZoomOut1: TMenuItem;
    ZoomAll1: TMenuItem;
    ZoomExtension1: TMenuItem;
    View1: TMenuItem;
    Maintainaspectratio1: TMenuItem;
    Showgrid1: TMenuItem;
    N2: TMenuItem;
    Layers1: TMenuItem;
    Print1: TMenuItem;
    All1: TMenuItem;
    Fitcurrent1: TMenuItem;
    Scale1: TMenuItem;
    Export1: TMenuItem;
    Bitmap1: TMenuItem;
    Metafile1: TMenuItem;
    All2: TMenuItem;
    Current1: TMenuItem;
    All3: TMenuItem;
    Current2: TMenuItem;
    SetWallpaper1: TMenuItem;
    OpenDialog2: TOpenDialog;
    Quote1: TMenuItem;
    Line1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure ViewportPanel1BeginRedraw(Sender: TObject);
    procedure ViewportPanel1EndRedraw(Sender: TObject);
    procedure Maintainaspectratio1Click(Sender: TObject);
    procedure Showgrid1Click(Sender: TObject);
    procedure Layers1Click(Sender: TObject);
    procedure All1Click(Sender: TObject);
    procedure Fitcurrent1Click(Sender: TObject);
    procedure Scale1Click(Sender: TObject);
    procedure All2Click(Sender: TObject);
    procedure Current1Click(Sender: TObject);
    procedure All3Click(Sender: TObject);
    procedure Current2Click(Sender: TObject);
    procedure ViewportPanel1MouseDown2D(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; WX, WY: Single; X,
      Y: Integer);
    procedure ViewportPanel1MouseMove2D(Sender: TObject;
      Shift: TShiftState; WX, WY: Single; X, Y: Integer);
    procedure SetWallpaper1Click(Sender: TObject);
    procedure Line1Click(Sender: TObject);
  private
    { Private declarations }
    FLastPicked: TObject2D;
    FDragPoint: TPoint2D;
    FOnQuote: Boolean;
    procedure DrawQuote(Line: TLine2D; Dist: TRealType);
    procedure MoveQuote(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2, LayerDlg;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  Tmp: TObject2D;
begin
  FLastPicked := nil;
  FOnQuote := False;
  { Set the drawing area extension. }
  Viewportpanel1.Extensions := Rect2D(-101, -101, 100, 100);
  { Draw something on the drawing area. }
  with CADCmp1 do
   begin
     Layers[240].Pen.Color := clGreen;
     Layers[240].Brush.Style := bsClear; { This ensure that the text will
                                           be with background transparent. }
     AddObject(-1, TFrame2D.Create(0, Point2D(0, 0), Point2D(100, 100)));
     Tmp := TText2D.Create(0, Rect2D(1, 70, 99, 99), 20, 'Hello world');
     TText2D(Tmp).DrawBox := False;
     TText2D(Tmp).ClippingFlags := DT_CENTER;
     AddObject(-1, Tmp);
     Tmp := TLine2D.Create(0, Point2D(-40, -40), Point2D(-10, -10));
     Tmp.Transform(Scale2D(2, 2));
     AddObject(-1, Tmp);
     AddObject(-1, TLine2D.Create(0, Point2D(-40, -40), Point2D(-10, -40)));
   end;
  ViewportPanel1.ZoomToExtensionClick(Self);
  MaintainaspectRatio1.Checked := ViewportPanel1.MaintainAspect;
  if ViewportPanel1.Viewport.GridStep.X > 0.0 then
   Showgrid1.Checked := True;
  with ViewportPanel1 do
   begin
     ZoomIn1.OnClick := ZoomInClick;
     ZoomOut1.OnClick := ZoomOutClick;
     ZoomAll1.OnClick := ZoomAllClick;
     ZoomExtension1.OnClick := ZoomToExtensionClick;
   end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.Load1Click(Sender: TObject);
var
  TmpStream: TFileStream;
begin
  if OpenDialog1.Execute then
   begin
     TmpStream := TFileStream.Create(OpenDialog1.FileName, fmOpenRead);
     try
       Screen.Cursor := crHourGlass;
       CADCmp1.LoadFromStream(TmpStream);
       Viewportpanel1.Extensions := CADCmp1.WorldExtension;
       ViewportPanel1.ZoomAllClick(Self);
     finally
       TmpStream.Free;
       Screen.Cursor := crDefault;
     end;
   end;
end;

procedure TForm1.Save1Click(Sender: TObject);
var
  TmpStream: TFileStream;
begin
  if SaveDialog1.Execute then
   begin
     TmpStream := TFileStream.Create(SaveDialog1.FileName, fmOpenWrite or fmCreate);
     try
      Screen.Cursor := crHourGlass;
      CADCmp1.SaveToStream(TmpStream);
     finally
       TmpStream.Free;
       Screen.Cursor := crDefault;
     end;
   end;
end;

procedure TForm1.ViewportPanel1BeginRedraw(Sender: TObject);
begin
  PopUpMenu1.AutoPopUp := False;
end;

procedure TForm1.ViewportPanel1EndRedraw(Sender: TObject);
begin
  PopUpMenu1.AutoPopUp := True;
end;

procedure TForm1.Maintainaspectratio1Click(Sender: TObject);
begin
  with ViewportPanel1 do
   begin
     MaintainAspect := not MaintainaspectRatio1.Checked;
     MaintainaspectRatio1.Checked := MaintainAspect;
     Viewport.Repaint;
   end;
end;

procedure TForm1.Showgrid1Click(Sender: TObject);
begin
  with ViewportPanel1.Viewport do
   begin
     if Showgrid1.Checked then
      GridStep := Point2D(0, 0)
     else
      GridStep := Point2D(10, 10);
     Repaint;
   end;
  Showgrid1.Checked := not Showgrid1.Checked;
end;

procedure TForm1.Layers1Click(Sender: TObject);
begin
  LayersDlg.ShowModal;
  ViewportPanel1.Viewport.Repaint;
end;

procedure TForm1.All1Click(Sender: TObject);
begin
  Printer.Orientation := poLandScape;
  Printer.BeginDoc;
  try
    with ViewportPanel1.Viewport do
     begin
       ViewportPanel1.BackGroundColor := clWhite;
       CopyOnCanvas(Printer.Canvas, cmExtensions, 1.0, 1.0);
       ViewportPanel1.BackGroundColor := clSilver;
     end;
  finally
    Printer.EndDoc;
  end;
end;

procedure TForm1.Fitcurrent1Click(Sender: TObject);
begin
  Printer.Orientation := poLandScape;
  Printer.BeginDoc;
  try
    with ViewportPanel1.Viewport do
     begin
       ViewportPanel1.BackGroundColor := clWhite;
       CopyOnCanvas(Printer.Canvas, cmFit, 1.0, 1.0);
       ViewportPanel1.BackGroundColor := clSilver;
     end;
  finally
    Printer.EndDoc;
  end;
end;

procedure TForm1.Scale1Click(Sender: TObject);
begin
  Printer.Orientation := poLandScape;
  Printer.BeginDoc;
  try
    with ViewportPanel1.Viewport do
     begin
       ViewportPanel1.BackGroundColor := clWhite;
       CopyOnCanvas(Printer.Canvas, cmScale, 1.0, 1.0);
       ViewportPanel1.BackGroundColor := clSilver;
     end;
  finally
    Printer.EndDoc;
  end;
end;

procedure TForm1.All2Click(Sender: TObject);
var
  TmpBmp: TBitmap;
begin
  TmpBmp := TBitmap.Create;
  try
    TmpBmp.Width := 200;
    TmpBmp.Height := 200;
    with ViewportPanel1.Viewport do
     begin
       ViewportPanel1.BackGroundColor := clWhite;
       CopyOnCanvas(TmpBmp.Canvas, cmExtensions, 1.0, 1.0);
       ViewportPanel1.BackGroundColor := clSilver;
     end;
     Clipboard.Assign(TmpBmp);
  finally
    TmpBmp.Free;
  end;
end;

procedure TForm1.Current1Click(Sender: TObject);
var
  TmpBmp: TBitmap;
begin
  TmpBmp := TBitmap.Create;
  try
    TmpBmp.Width := 200;
    TmpBmp.Height := 200;
    with ViewportPanel1.Viewport do
     begin
       ViewportPanel1.BackGroundColor := clWhite;
       CopyOnCanvas(TmpBmp.Canvas, cmFit, 1.0, 1.0);
       ViewportPanel1.BackGroundColor := clSilver;
     end;
     Clipboard.Assign(TmpBmp);
  finally
    TmpBmp.Free;
  end;
end;

procedure TForm1.All3Click(Sender: TObject);
var
  TmpMeta: TMetafile;
  TmpMetaCnv: TMetafileCanvas;
  RefDC: HDC;
begin
  TmpMeta := TMetafile.Create;
  RefDC := GetDC(0);
  try
    TmpMeta.Width := GetDeviceCaps(RefDC, HORZRES);
    TmpMeta.Height := GetDeviceCaps(RefDC, VERTRES);
    TmpMetaCnv := TMetafileCanvas.Create(TmpMeta, 0);
    try
     with ViewportPanel1.Viewport do
      begin
        ViewportPanel1.BackGroundColor := clWhite;
        CopyOnCanvas(TmpMetaCnv, cmExtensions, 1.0, 1.0);
        ViewportPanel1.BackGroundColor := clSilver;
      end;
    finally
     TmpMetaCnv.Free;
    end;
    Clipboard.Assign(TmpMeta);
  finally
    TmpMeta.Free;
    ReleaseDC(0, RefDC);
  end;
end;

procedure TForm1.Current2Click(Sender: TObject);
var
  TmpMeta: TMetafile;
  TmpMetaCnv: TMetafileCanvas;
  RefDC: HDC;
begin
  TmpMeta := TMetafile.Create;
  RefDC := GetDC(0);
  try
    TmpMeta.Width := GetDeviceCaps(RefDC, HORZRES);
    TmpMeta.Height := GetDeviceCaps(RefDC, VERTRES);
    TmpMetaCnv := TMetafileCanvas.Create(TmpMeta, RefDC);
    try
     with ViewportPanel1.Viewport do
      begin
        ViewportPanel1.BackGroundColor := clWhite;
        CopyOnCanvas(TmpMetaCnv, cmFit, 1.0, 1.0);
        ViewportPanel1.BackGroundColor := clSilver;
      end;
    finally
     TmpMetaCnv.Free;
    end;
    Clipboard.Assign(TmpMeta);
  finally
    TmpMeta.Free;
    ReleaseDC(0, RefDC);
  end;
end;

procedure TForm1.SetWallpaper1Click(Sender: TObject);
var
  TmpBmp: TBitmap;
  Tmp: TObject2D;
begin
  if OpenDialog2.Execute then
   begin
     TmpBmp := TBitmap.Create;
     try
       TmpBmp.LoadFromFile(OpenDialog2.FileName);
       with ViewportPanel1.Extensions do
        Tmp := TBitmap2D.Create(0, FirstEdge, SecondEdge, TmpBmp);
       with CADCmp1 do
        InsertObject(-1, ObjectsList.First.ID, Tmp);
       ViewportPanel1.Viewport.Repaint;
     finally
       TmpBmp.Free;
     end;
   end;
end;

procedure TForm1.Line1Click(Sender: TObject);
begin
  FOnQuote := True;
end;

procedure TForm1.ViewportPanel1MouseDown2D(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; WX, WY: Single; X, Y: Integer);
var
  TmpInt: Integer;
begin
  if FLastPicked = nil then
   begin
     FLastPicked := ViewportPanel1.Viewport.PickObject(Point2D(WX, WY), 4,
                                                       TmpInt);
     FDragPoint := Point2D(WX, WY);
     if FOnQuote and (FLastPicked is TLine2D) then
      begin
        DrawQuote(FLastPicked as TLine2D, 5);
        FLastPicked := nil;
        FOnQuote := False;
      end;
   end
  else
   begin
     FLastPicked := nil;
     ViewportPanel1.Viewport.Repaint;
   end;
end;

procedure TForm1.ViewportPanel1MouseMove2D(Sender: TObject;
  Shift: TShiftState; WX, WY: Single; X, Y: Integer);
begin
  if FLastPicked <> nil then
   with ViewportPanel1.Viewport do
    begin
      Refresh;
      WhereToDraw := [wdCanvas];
      FLastPicked.MoveTo(Point2D(WX, WY), FDragPoint);
      DrawObject(FLastPicked);
      WhereToDraw := [wdOffScreen];
      FDragPoint := Point2D(WX, WY);
   end;
end;

{
procedure TForm1.MoveQuote(Sender: TObject);
var
  Cont2D: TContainer2D;
  TmpLine: TLine2D;
begin
  if (Sender is TLine2D) and (TLine2D(Sender).Tag <> 0) then
   begin
     Cont2D := TContainer2D(TLine2D(Sender).Tag);
     Cont2D.ModelTransform := TLine2D(Sender).ModelTransform;
   end;
end;

procedure TForm1.DrawQuote(Line: TLine2D; Dist: TRealType);
var
  TmpCont: TContainer2D;
  TmpText: TText2D;
  Pt1, Pt2: TPoint2D;
  Rect1: TRect2D;
  Ang, Len, DistX, DistY: TRealType;
begin
  if Line.Tag <> 0 then Exit;
  Pt1 := Line.Points[0];
  Pt2 := Line.Points[1];
  if Pt2.Y - Pt1.Y <> 0.0 then
   begin
     Ang := ArcTan(-(Pt2.X - Pt1.X) / (Pt2.Y - Pt1.Y));
     Len := Sqrt(SumOfSquares([Pt2.X - Pt1.X, Pt2.Y - Pt1.Y]));
     DistX := Dist / cos(Ang);
     DistY := Dist / sin(Ang);
     Rect1.Left := Pt1.X - DistX;
     Rect1.Bottom := Pt1.Y - DistY;
     Rect1.Right := Pt2.X - DistX;
     Rect1.Top := Pt2.Y - DistY;
   end
  else
   begin
     Ang := 0;
     Len := Abs(Pt2.X - Pt1.X);
     Rect1.Left := Pt1.X;
     Rect1.Bottom := Pt1.Y + Dist;
     Rect1.Right := Pt2.X;
     Rect1.Top := Pt2.Y + Dist;
   end;
  CADCmp1.CurrentLayer := 240;
  TmpText := TText2D.Create(0, Rect1, 5, Format('%f', [Len]));
  TmpText.DrawBox := False;
  TmpText.ClippingFlags := DT_CENTER or DT_VCENTER or DT_SINGLELINE
                           or DT_NOCLIP;
  TmpCont := TContainer2D.Create(0,
              [TLine2D.Create(0, Rect1.FirstEdge, Rect1.SecondEdge),
               TLine2D.Create(1, Pt1, Rect1.FirstEdge),
               TLine2D.Create(2, Pt2, Rect1.SecondEdge),
               TmpText]);
  TmpCont.Enabled := False;
  TmpCont.ModelTransform := Line.ModelTransform;
  CADCmp1.AddObject(-1, TmpCont);
  Line.Tag := LongInt(TmpCont);
  Line.OnChange := MoveQuote;
  with ViewportPanel1.Viewport do
   begin
     DrawObject(TmpCont);
     Refresh;
   end;
end;
}

procedure AdjustQuote(Line: TLine2D; Dist: TRealType);
var
  TmpCont: TContainer2D;
  Pt1, Pt2: TPoint2D;
  Rect1: TRect2D;
  Ang, Len, DistX, DistY: TRealType;
begin
  if Line.Tag = 0 then Exit;
  TmpCont := TContainer2D(Line.Tag);
  Pt1 := TransformPoint2D(Line.Points[0], Line.ModelTransform);
  Pt2 := TransformPoint2D(Line.Points[1], Line.ModelTransform);
  if Pt2.Y - Pt1.Y <> 0.0 then
   begin
     Ang := ArcTan(-(Pt2.X - Pt1.X) / (Pt2.Y - Pt1.Y));
     Len := Sqrt(SumOfSquares([Pt2.X - Pt1.X, Pt2.Y - Pt1.Y]));
     DistX := Dist / cos(Ang);
     DistY := Dist / sin(Ang);
     Rect1.Left := Pt1.X - DistX;
     Rect1.Bottom := Pt1.Y - DistY;
     Rect1.Right := Pt2.X - DistX;
     Rect1.Top := Pt2.Y - DistY;
   end
  else
   begin
     Ang := 0;
     Len := Abs(Pt2.X - Pt1.X);
     Rect1.Left := Pt1.X;
     Rect1.Bottom := Pt1.Y + Dist;
     Rect1.Right := Pt2.X;
     Rect1.Top := Pt2.Y + Dist;
   end;
  with TmpCont do
   begin
     with TLine2D(Objects.First) do
      begin
        Points[0] := Rect1.FirstEdge;
        Points[1] := Rect1.SecondEdge;
      end;
     with TLine2D(Objects.Next) do
      begin
        Points[0] := Pt1;
        Points[1] := Rect1.FirstEdge;
      end;
     with TLine2D(Objects.Next) do
      begin
        Points[0] := Pt2;
        Points[1] := Rect1.SecondEdge;
      end;
     with TText2D(Objects.Next) do
      begin
        Points[0] := Rect1.FirstEdge;
        Points[1] := Rect1.SecondEdge;
        Text := Format('%f', [Len]);
      end;
     UpdateExtension;
   end;
end;

procedure TForm1.MoveQuote(Sender: TObject);
begin
  if (Sender is TLine2D) then
   AdjustQuote(TLine2D(Sender), 5);
end;

procedure TForm1.DrawQuote(Line: TLine2D; Dist: TRealType);
var
  TmpCont: TContainer2D;
  TmpText: TText2D;
begin
  if Line.Tag <> 0 then Exit;
  CADCmp1.CurrentLayer := 240;
  TmpText := TText2D.Create(0, Rect2D(0, 0, 0, 0), 5, '');
  TmpText.DrawBox := False;
  TmpText.ClippingFlags := DT_CENTER or DT_VCENTER or DT_SINGLELINE
                           or DT_NOCLIP;
  TmpCont := TContainer2D.Create(0,
              [TLine2D.Create(0, Point2D(0, 0), Point2D(0, 0)),
               TLine2D.Create(1, Point2D(0, 0), Point2D(0, 0)),
               TLine2D.Create(2, Point2D(0, 0), Point2D(0, 0)),
               TmpText]);
  TmpCont.Enabled := False;
  Line.Tag := LongInt(TmpCont);
  AdjustQuote(Line, Dist);
  Line.OnChange := MoveQuote;
  CADCmp1.AddObject(-1, TmpCont);
  with ViewportPanel1.Viewport do
   begin
     DrawObject(TmpCont);
     Refresh;
   end;
end;

end.

